package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.TestBbb;
import com.izouma.awesomeadmin.service.TestBbbService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/testBbb")
public class TestBbbController {

    @Autowired
    private TestBbbService testBbbService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(TestBbb record) {
        List<TestBbb> pp = testBbbService.getTestBbbList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getTestBbb", method = RequestMethod.GET)
    @ResponseBody
    public Result getTestBbb(@RequestParam(required = false, value = "id") String id) {
        TestBbb data = testBbbService.getTestBbbById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(TestBbb record) {
        TestBbb data = testBbbService.getTestBbb(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, TestBbb record) {
        Map<String, Object> result = new HashMap<>();

        List<TestBbb> pp =testBbbService.getTestBbbByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(TestBbb record) {
        boolean num = testBbbService.createTestBbb(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateTestBbb(TestBbb record) {
        boolean num = testBbbService.updateTestBbb(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteTestBbb(@RequestParam(required = true, value = "id") String id) {

        boolean num = testBbbService.deleteTestBbb(id);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, TestBbb record) throws Exception {

    List<TestBbb> testBbbs = testBbbService.getTestBbbList(record);


        String sheetName = "test_bbb";
        String titleName = "测试表BBB数据表";
        String fileName = "测试表BBB表";
        int columnNumber = 6;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "名称1" ,   "名称2" ,   "名称3" ,   "名称4"  };
        String[][] dataList = new String[testBbbs.size()][6];

        for (int i = 0; i < testBbbs.size(); i++) {

                        dataList[i][0] = String.valueOf(testBbbs.get(i).getId());
                        dataList[i][1] = String.valueOf(testBbbs.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(testBbbs.get(i).getNameAaa());
                        dataList[i][3] = String.valueOf(testBbbs.get(i).getNameBbb());
                        dataList[i][4] = String.valueOf(testBbbs.get(i).getNameCcc());
                        dataList[i][5] = String.valueOf(testBbbs.get(i).getNameDdd());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

